Subject: Re: [PATCH 1/3] netlink: fix NETLINK_RECV_NO_ENOBUFS in netlink_set_err()

From: Patrick McHardy <[email-masked]>
Date: Thu, 18 Mar 2010 17:46:46 +0100

Pablo Neira Ayuso wrote:
> Patrick McHardy wrote:
>> Pablo Neira Ayuso wrote:
>>> Yes, allocation is a different situation but we still report ENOBUFS to
>>> user-space. I think that NETLINK_RECV_NO_ENOBUFS is there to a) disable
>>> ENOBUFS reports to user-space and b) disable Netlink congestion.
>>>
>>>> Is there any problem with these errors?
>>> Specifically in ctnetlink, if we fail to allocate a message in ctnetlink
>>> and NETLINK_RECV_NO_ENOBUFS is set, we still lose an event and that
>>> should not happen.
>> I assume you mean "not set"? Otherwise I fail to follow :)
> 
> OK, I'll try again :-)
> 
> Currently, no matter if NETLINK_RECV_NO_ENOBUFS is set or not: if we
> fail to allocate the netlink message, then ctnetlink_conntrack_event()
> returns 0. Thus, we report ENOBUFS to user-space and we lose the event.
> 
> With my patches, if NETLINK_RECV_NO_ENOBUFS is set and we fail to
> allocate the message, we don't report ENOBUFS and we don't lose the event.

That last part is what keeps confusing me. With your patch, if the
ENOBUFS options is set, we don't report the error to userspace
and therefore don't return it to conntrack, thus we *do* loose the
event. Which is correct however.

Did I get it right this time? :)